#include-once

Global Const $SRCCOPY = 0x00CC0020
Global Const $DIB_RGB_COLORS = 0
Global Const $CF_BITMAP = 2
Global Const $OBJ_PAL = 5
Global $TIMER =0
Global $DIFF = 5000
Global Const $SIZE_RESTORED = 0
Global Const $SIZE_MINIMIZED = 1
;----------------------------------------------------------
Global Const $tagBITS = "byte[1024]"
; 24bytes ptr is to BITS
Global Const $tagBITMAP = "int;int;int;int;ushort;ushort;ptr"
Global Const $tagBITMAPINFOHEADER = "dword;int;int;ushort;ushort;dword;dword;int;int;dword;dword";
;Global Const $tagQUAD = "byte[4]"
Global Const $tagBITMAPFILEHEADER = "ushort;dword;ushort;ushort;dword"
; has BITMAPINFOHEADER and RGBQUAD
Global Const $tagBITMAPINFO = "prt;ptr"
;----------------------------------------------------------
Global $StructError[5] = ["No error", "Variable passed to DllStructCreate was not a string. ", _
	"There is an unknown Data Type in the string passed.", _
	"Failed to allocate the memory needed for the struct, or Pointer = 0.", "Error allocating memory for the passed string."]

Global $wide
Global $tall
Global $bpp

Func GetClipBoard(ByRef $pbuf)
	Local $hBitmap;
	Local $hMyDC
	Local $bmBitmap = DllStructCreate($tagBITMAP)
	Local $Me = DllCall("user32.dll", "hwnd", "GetDesktopWindow")
	If IsArray($Me) Then
		OpenClipboard($Me[0])
		If (IsClipboardFormatAvailable($CF_BITMAP)) Then
			$hBitmap = GetClipboardData($CF_BITMAP)
			If ($hBitmap) Then
				GetObject($hBitmap, DllStructGetSize($bmBitmap), DllStructGetPtr($bmBitmap))
				
				$hMyDC = GetDC(0)
				If ($hMyDC) Then
					Local $width = DllStructGetData($bmBitmap, 2)
					Local $height = DllStructGetData($bmBitmap, 3)
					Local $DIBHead = DllStructCreate($tagBITMAPINFOHEADER & ";" & $tagBITS)
					DllStructSetData($DIBHead, 1, 40)
					DllStructSetData($DIBHead, 2, $width)
					DllStructSetData($DIBHead, 3, $height)
					DllStructSetData($DIBHead, 4, 1)
					$bpp = DllStructGetData($bmBitmap, 6)
					If $bpp > 16 Then $bpp = 24
					DllStructSetData($DIBHead, 5, $bpp)
					
					Local $iBitmap = CreateDIBSection($hMyDC, $DIBHead, $DIB_RGB_COLORS, 0, 0, 0)
					Local $iSrc = CreateCompatibleDC(0)
					Local $hOldObj = SelectObject($iSrc, $hBitmap)
					Local $iDest = CreateCompatibleDC(0)
					Local $hNewObj = SelectObject($iDest, $iBitmap)
					if (DllStructGetData($DIBHead, 5) <= 8) Then
						Local $hPalette = GetCurrentObject($iSrc, $OBJ_PAL);
						if ($hPalette) Then
							Local $pal = DllStructCreate("byte[1024]")
							Local $nEntries = GetPaletteEntries($hPalette, 0, 256, DllStructGetPtr($pal));
							if ($nEntries) Then
								For $x = 1 to ($nEntries * 4) Step 4
									DllStructSetData($pal, 1, 0, $x)
								Next
							EndIf
						EndIf
					EndIf
					BitBlt($iDest, 0, 0, $width, $height, $iSrc, 0, 0, $SRCCOPY)
					$wide = DllStructGetData($DIBHead, 2)
					$tall = DllStructGetData($DIBHead, 3)
					Local $size = (((($wide * 32) + 31) / 32) * 4) * Abs($tall)
					DllStructSetData($DIBHead, 7, $size)
					$pbuf = DllStructCreate("byte[" & DllStructGetData($DIBHead, 7) & "]")
					GetDIBits($iDest, $iBitmap, 0, $tall, DllStructGetPtr($pbuf), DllStructGetPtr($DIBHead), 0)
				EndIf
				
				; Release struct.
				CloseClipboard()
				ReleaseDC(0, $iSrc)
				DeleteDC($iSrc)
				ReleaseDC(0, $iDest)
				DeleteDC($iDest)
				DeleteObject($hBitmap)
				$hBitmap = $iBitmap
				DeleteObject($hOldObj)
				DeleteObject($hNewObj)
				ReleaseDC(0, $hMyDC)
				DeleteDC($hMyDC)
				$bmBitmap = 0
				$pal = 0
				$DIBHead = 0
			EndIf
			Return $hBitmap
		EndIf
	EndIf
	
EndFunc

Func CreateDib($inDib, $sFile = "", $ProgressText="Progress... ")
	If $inDib = 0 Then
		SetError(1)
		Return 0
	EndIf
	$Precent = 0
	If $sFile = "" Then $sFile = @DesktopCommonDir & "\" & @MON & @MDAY & @YEAR & @HOUR & @MIN & @SEC & ".bmp"
	Local $vret, $biWidth, $biHeight, $biBitCount, $biCompression, $biClrUsed, $size;, $biSizeImage, $bmColors, $bmBit, $FileHead
	Local $DIBHead, $bmInfoHeader, $bmBitmap, $pbuf
	$Precent += 10
	ProgressSet($Precent, $ProgressText & $Precent & "%")
	$bmBitmap = DllStructCreate($tagBITMAP)
	Local $NumCols, $DeskDC
	If (GetObject($inDib, DllStructGetSize($bmBitmap), DllStructGetPtr($bmBitmap)) = 0) Then Return 0
	$Precent += 10
	ProgressSet($Precent, $ProgressText & $Precent & "%")
	If (DllStructGetData($bmBitmap, 7) = 0) Then Return 0
	$DIBHead = DllStructCreate($tagBITMAPINFOHEADER & ";" & $tagBITS)
	$bmInfoHeader = DllStructCreate($tagBITMAPINFOHEADER, DllStructGetPtr($DIBHead, 1))
	DllStructSetData($DIBHead, 1, DllStructGetSize($bmInfoHeader))
	$bmInfoHeader = 0
	$DeskDC = GetDC(0)
	$vret = GetDIBits($DeskDC, $inDib, 0, 0, 0, DllStructGetPtr($DIBHead), 0)
	$Precent += 10
	ProgressSet($Precent, $ProgressText & $Precent & "%")
	If ($vret) Then
		$biWidth = DllStructGetData($DIBHead, 2)
		$biHeight = DllStructGetData($DIBHead, 3)
		$biBitCount = DllStructGetData($DIBHead, 5)
		$Precent += 10
		ProgressSet($Precent, $ProgressText & $Precent & "%")
		$biCompression = DllStructGetData($DIBHead, 6)
		$biClrUsed = DllStructGetData($DIBHead, 10)
		If $biBitCount < 8 Then
			$NumCols = $biClrUsed
			If ($NumCols = 0) Then $NumCols = 2 ^ $biBitCount
		ElseIf ($biCompression) Then
			If ($biCompression = 3) Then
				$NumCols = 3
			Else
				ReleaseDC(0, $DeskDC)
				$Precent += 10
				DeleteDC($DeskDC)
				Return 0
			EndIf
		EndIf
		$Precent += 10
		ProgressSet($Precent, $ProgressText & $Precent & "%")
		$size = (((($biWidth * $biBitCount) + 31) / 32) * 4) * Abs($biHeight)
		DllStructSetData($DIBHead, 7, $size)
		$pbuf = DllStructCreate("byte[" & $size & "]")
		$vret = GetDIBits($DeskDC, $inDib, 0, Abs($biHeight), DllStructGetPtr($pbuf), DllStructGetPtr($DIBHead), 0)
		$Precent += 10
		ProgressSet($Precent, $ProgressText & $Precent & "%")
		If $vret = 0 Then
			ReleaseDC(0, $DeskDC)
			DeleteDC($DeskDC)
			Return SetError(1)
		EndIf
		DllStructSetData($DIBHead, 10, $NumCols)
		DllStructSetData($DIBHead, 11, $NumCols)
		$Precent += 10
		Local $bSaved = SaveDibToFile($sFile, $DIBHead, $pbuf)
		If $bSaved = True Then
			;MsgBox(266288, "Save", " : " & $sFile,3)
		Else
			;MsgBox(266288, "Save", "! Fuck! Errors were encounterd while saving")
		EndIf
		$Precent += 10
		ProgressSet($Precent, $ProgressText & $Precent & "%")
		Sleep(100)
		ReleaseDC(0, $DeskDC)
		Sleep(100)
		DeleteDC($DeskDC)
		$Precent += 10
		ProgressSet($Precent, $ProgressText & $Precent & "%")
		Sleep(100)
		DeleteObject($inDib)
		$DIBHead = 0
		$bmBitmap = 0
		$pbuf = 0
		$DeskDC = 0
	EndIf
	$Precent += 10
	ProgressSet($Precent, $ProgressText & $Precent & "%")
EndFunc   ;==>CreateDib

Func SaveDibToFile($sFile, $hInfo, $hBuffer)
	Local $bSaved = False
	Local $hFileHead = DllStructCreate($tagBITMAPFILEHEADER)
	DllStructSetData($hFileHead, 1, 0x04d42)
	Local $bfOffBits = DllStructGetSize($hFileHead) + DllStructGetSize($hInfo)
	DllStructSetData($hFileHead, 5, $bfOffBits)
	DllStructSetData($hFileHead, 2, DllStructGetData($hInfo, 7) + $bfOffBits)
	Local $hFile = _APIFileOpen ($sFile, 1)
	If $hFile Then
		If _BinaryFileWrite ($hFile, $hFileHead) Then
			Sleep(100)
			If _BinaryFileWrite ($hFile, $hInfo) Then
				Sleep(100)
				If _BinaryFileWrite ($hFile, $hBuffer) Then $bSaved = True
			EndIf
		EndIf
	EndIf
	_APIFileClose ($hFile)
	Return $bSaved
EndFunc   ;==>SaveDibToFile

Func GetDC($hWnd)
	Local $hDC = DllCall('user32.dll', 'int', 'GetDC', _
			'hwnd', $hWnd)
	Return $hDC[0]
EndFunc   ;==>GetDC

Func ReleaseDC($hWnd, $hDC)
	Local $bResult = DllCall('user32.dll', 'int', 'ReleaseDC', _
			'hwnd', $hWnd, _
			'hwnd', $hDC)
	Return $bResult[0]
EndFunc   ;==>ReleaseDC

Func OpenClipboard($hWnd)
	Local $v_ret = DllCall("user32.dll", "int", "OpenClipboard", "hwnd", $hWnd)
	Return $v_ret[0]
EndFunc   ;==>OpenClipboard

Func CloseClipboard()
	Local $v_ret = DllCall("user32.dll", "int", "CloseClipboard")
	Return $v_ret[0]
EndFunc   ;==>CloseClipboard

Func IsClipboardFormatAvailable($CB_Format)
	Local $v_ret = DllCall("user32.dll", "int", "IsClipboardFormatAvailable", "int", $CB_Format)
	Return $v_ret[0]
EndFunc   ;==>IsClipboardFormatAvailable

Func GetClipboardData($CB_Format)
	Local $v_ret = DllCall("user32.dll", "int", "GetClipboardData", "int", $CB_Format)
	Return $v_ret[0]
EndFunc   ;==>GetClipboardData

Func GetObject($hObj, $nCount, $ptrObj)
	;	Private Declare Function GetObject Lib "GDI32.dll" Alias "GetObjectA" ( ByVal hObject As Long, ByVal nCount As Long, ByRef lpObject As Any) As Long
	Local $v_ret = DllCall('gdi32.dll', 'int', 'GetObject', _
			'hwnd', $hObj, _
			'int', $nCount, _
			'ptr', $ptrObj)
	Return $v_ret[0]
EndFunc   ;==>GetObject

Func GetDIBits($aHdc, $hBitmap, $nStartScan, $nNumScans, $ptrBits, $ptrBI, $wUsage)
	Local $v_ret = DllCall("gdi32.dll", "int", "GetDIBits", _
			"int", $aHdc, _
			"hwnd", $hBitmap, _
			"int", $nStartScan, _
			"int", $nNumScans, _
			"ptr", $ptrBits, _
			"ptr", $ptrBI, _
			"int", $wUsage)
	
	Return $v_ret[0]
EndFunc   ;==>GetDIBits

Func SelectObject($hDC, $hObj)
	Local $hOldObj = DllCall('gdi32.dll', 'int', 'SelectObject', _
			'hwnd', $hDC, _
			'hwnd', $hObj)
	Return $hOldObj[0]
EndFunc   ;==>SelectObject

Func DeleteObject($hObj)
	Local $bResult = DllCall('gdi32.dll', 'int', 'DeleteObject', _
			'hwnd', $hObj)
	Return $bResult[0]
EndFunc   ;==>DeleteObject

Func CreateCompatibleDC($hDC)
	Local $hCompDC = DllCall('gdi32.dll', 'hwnd', 'CreateCompatibleDC', _
			'hwnd', $hDC)
	Return $hCompDC[0]
EndFunc   ;==>CreateCompatibleDC

Func DeleteDC($hDC)
	Local $bResult = DllCall('gdi32.dll', 'int', 'DeleteDC', _
			'hwnd', $hDC)
	Return $bResult[0]
EndFunc   ;==>DeleteDC

Func BitBlt($hDCDest, $nXDest, $nYDest, $nWidth, $nHeight, $hDCSrc, $nXSrc, $nYSrc, $nOpCode)
	Local $bResult = DllCall('gdi32.dll', 'int', 'BitBlt', _
			'hwnd', $hDCDest, _
			'int', $nXDest, _
			'int', $nYDest, _
			'int', $nWidth, _
			'int', $nHeight, _
			'hwnd', $hDCSrc, _
			'int', $nXSrc, _
			'int', $nYSrc, _
			'long', $nOpCode)
	Return $bResult[0]
EndFunc   ;==>BitBlt

Func GetCurrentObject($hDC, $uiType)
	Local $v_ret = DllCall("gdi32.dll", "hwnd", "GetCurrentObject", "hwnd", $hDC, "int", $uiType)
	Return $v_ret[0]
EndFunc   ;==>GetCurrentObject

Func GetPaletteEntries($hPal, $uiStart, $uiEntries, $ptrPalArray)
	Local $v_ret = DllCall("gdi32.dll", "int", "GetPaletteEntries", "hwnd", $hPal, "int", $uiStart, "int", $uiEntries, "ptr", DllStructGetPtr($ptrPalArray))
	Return $v_ret[0]
EndFunc   ;==>GetPaletteEntries

Func CreateDIBSection($hDC, $pBmi, $iUsage = 0, $ppvBits = 0, $hSection = 0, $dwOffset = 0)
	Local $iBitmap = DllCall("gdi32.dll", "hwnd", "CreateDIBSection", "int", $hDC, "ptr", DllStructGetPtr($pBmi), _
			"int", $iUsage, "ptr", $ppvBits, "hwnd", $hSection, "int", $dwOffset)
	Return $iBitmap[0]
EndFunc   ;==>CreateDIBSection



; _APIFileOpen( <FileName> )
;
; Returns a "REAL" file handle for reading and writing.
; The return value comes directly from "CreateFile" api.
Func _APIFileOpen( $szFile,$Optioins = 0 )
	Local $GENERIC_READ = 0x80000000, $GENERIC_WRITE = 0x40000000
	Local $STANDARD_RIGHTS_REQUIRED = 0x000f0000
	Local $SYNCHRONIZE = 0x00100000
	Local $FILE_ALL_ACCESS = BitOR(0x1FF, $STANDARD_RIGHTS_REQUIRED, $SYNCHRONIZE)

	Local $OPEN_ALWAYS = 4, $CREATE_ALWAYS = 2, $FILE_ATTRIBUTE_NORMAL = 0x00000080
	Local $AFO_h, $AFO_ret
	Local $AFO_bWrite = 1

		$AFO_h = DllCall( "kernel32.dll", "hwnd", "CreateFile", _
				"str", $szFile, _
				"long", $FILE_ALL_ACCESS, _
				"long", 7, _
				"ptr", 0, _
				"long", $OPEN_ALWAYS, _
				"long", $FILE_ATTRIBUTE_NORMAL, _
				"long", 0 )
		If $AFO_h[0] = 0xFFFFFFFF Then
			If $Optioins = 1 Then
				$AFO_bWrite = 1
				$AFO_h = DllCall( "kernel32.dll", "hwnd", "CreateFile", _
						"str", $szFile, _
						"long", $GENERIC_WRITE, _
						"long", 7, _
						"ptr", 0, _
						"long", $CREATE_ALWAYS, _
						"long", $FILE_ATTRIBUTE_NORMAL, _
						"long", 0 )
			Else
				$AFO_bWrite = 0
				$AFO_h = DllCall( "kernel32.dll", "hwnd", "CreateFile", _
						"str", $szFile, _
						"long", $GENERIC_READ, _
						"long", 7, _
						"ptr", 0, _
						"long", $CREATE_ALWAYS, _
						"long", $FILE_ATTRIBUTE_NORMAL, _
						"long", 0 )	
			Endif
	EndIf
	$AFO_ret = DLLCall("kernel32.dll","int","GetLastError")
	SetError($AFO_ret[0],$AFO_bWrite)
	Return $AFO_h[0]
EndFunc
; _APIFileClose( <FileHandle> )
;
; The return value comes directly from "CloseHandle" api.
Func _APIFileClose( ByRef $hFile )
	Local $AFC_r
	$AFC_r = DllCall( "kernel32.dll", "int", "CloseHandle", _
			"hwnd", $hFile )
	Return $AFC_r[0]
EndFunc


; _APIFileSetPos( <FileHandle>, <Position in the file to read/write to/from> )
;
; The return value comes directly from "SetFilePointer" api.
Func _APIFileSetPos( ByRef $hFile, ByRef $nPos )
	Local $FILE_BEGIN = 0 
	Local $AFSP_r
	$AFSP_r = DllCall( "kernel32.dll", "long", "SetFilePointer", _
			"hwnd",$hFile, _
			"long",$nPos, _
			"long_ptr",0, _
			"long",$FILE_BEGIN )
	Return $AFSP_r[0] 
EndFunc


; _BinaryFileRead( <FileHandle>, <ptr buffer>)
;
; Reads file into struct <ptr buffer>
; Return from ReadFile api.
Func _BinaryFileRead( ByRef $hFile, ByRef $buff_ptr, $buff_bytes = 0)
	Local $AFR_r
	If $buff_bytes = 0 Then $buff_bytes = DllStructGetSize($buff_ptr)
	$AFR_r = DllCall( "kernel32.dll", "int", "ReadFile", _
			"hwnd", $hFile, _
			"ptr",DllStructGetPtr($buff_ptr), _
			"long",$buff_bytes, _
			"long_ptr",0, _
			"ptr",0 )
	Return $AFR_r[0]
EndFunc


; _BinaryFileWrite( <FileHandle>, <ptr buffer>)
;
; Returns # of Bytes written. 
; Sets @error to the return from WriteFile api.
Func _BinaryFileWrite( ByRef $hFile, ByRef $buff_ptr, $buff_bytes = 0)
	Local $AFW_r
	If $buff_bytes = 0 Then $buff_bytes = DllStructGetSize($buff_ptr)
	$AFW_r = DllCall( "kernel32.dll", "int", "WriteFile", _
			"hwnd", $hFile, _
			"ptr",DllStructGetPtr($buff_ptr), _
			"long",$buff_bytes, _
			"long_ptr",0, _
			"ptr",0 )
	SetError($AFW_r[0],$AFW_r[4])
	Return $AFW_r[4]
EndFunc

