#cs
Print Screen Checker - Program that monitoring after 'Print Screen' button (can be changed), and When button is pressed, program execute selected editor with captured image.

Author: G.Sandler - Copyright  2007 CreatoR's Lab (G.Sandler). All rights reserved.
#ce


#include <APIFileReadWrite.au3>
#Include <Constants.au3>
#Include <GuiConstants.au3>
#Include <GuiCombo.au3>
#include <Misc.au3>
Opt("TrayMenuMode", 1)
Opt("TrayOnEventMode", 1)
Opt("RunErrorsFatal", 0)
Opt("ExpandEnvStrings", 1)
Opt("ExpandVarStrings", 1)

FileInstall("PrintScreenChecker.ini", @ScriptDir & "\PrintScreenChecker.ini")

Global $Config = @ScriptDir & "\PrintScreenChecker.ini"
Global $UsedLang = IniRead($Config, "Prefs", "Language", "Lng_English")

Global $IconFile = @ScriptDir & "\PrintScreenChecker.bin"
If @Compiled Then $IconFile = @ScriptFullPath

Global $OffIconID = 1
Global $OnIconID = 2

Global $Main_Icon = @ScriptDir & "\Icon.ico"


Global $OptionsGui = "", $Group, $ImageLabel, $TempFileLabel, $HotKeyLabel, $OK, $LangCombo, $ImageEditorCombo, $TempBmpFileInput
Global $HotKeyCombo, $DelTmpFileCB, $Options, $TurnOn, $TurnOff, $Exit, $Cancel

Global $OldUsedLang

Global $ImageEditor = IniRead($Config, "Prefs", "Image Editor", "")
If $ImageEditor = "" Then $ImageEditor = "MSPaint.exe"

Global $ImageEditorList = IniRead($Config, "Prefs", "Image Editor List", "")
If $ImageEditorList = "" Then $ImageEditorList = "MSPaint.exe"

Global $TempBmpFile = IniRead($Config, "Prefs", "Temp File", "")
If $TempBmpFile = "" Then $TempBmpFile = @TempDir & "\CBCapture.bmp"

Global $HotKey = IniRead($Config, "Prefs", "HotKey", "Print Screen")
Global $IsOn = IniRead($Config, "Prefs", "On/Off", "1")
Global $DeleteTmpFile = IniRead($Config, "Prefs", "Delete Temp File", "1")

Global $Msg = Translate($Config)

$HotKeySet = SetHotKey($HotKey)
If $IsOn = 1 Then HotKeySet($HotKeySet, "PrintScreen")

TraySetClick(16)
TraySetToolTip(StringReplace($Msg[18], "%S", _Iif($IsOn=1, $Msg[3], $Msg[4])))
TraySetOnEvent($TRAY_EVENT_PRIMARYDOWN, "SwitchOnOff")

Global $Options = TrayCreateItem($Msg[2])
TrayItemSetOnEvent($Options, "Options")

TrayCreateItem("")

Global $TurnOn = TrayCreateItem($Msg[3], -1, -1, 1)
TrayItemSetOnEvent($TurnOn, "SwitchOnOff")

Global $TurnOff = TrayCreateItem($Msg[4], -1, -1, 1)
TrayItemSetOnEvent($TurnOff, "SwitchOnOff")

TrayCreateItem("")

Global $Exit = TrayCreateItem($Msg[5])
TrayItemSetOnEvent($Exit, "Quit")

If $IsOn = 1 Then
	TrayItemSetState($TurnOn, 1)
	TrayItemSetState($TurnOff, 0)
	TraySetIcon($IconFile, $OnIconID)
Else
	TrayItemSetState($TurnOn, 0)
	TrayItemSetState($TurnOff, 1)
	TraySetIcon($IconFile, $OffIconID)
EndIf

TrayTip($Msg[19], $Msg[20], 15, 1)

While 1
	Sleep(10)
	If $OptionsGui <> "" And WinExists($OptionsGui) Then
		While 1
			$GuiMsg = GUIGetMsg()
			Switch $GuiMsg
				Case $LangCombo
					$UsedLang = "Lng_" & GUICtrlRead($LangCombo)
					$Msg = Translate($Config)
					WinSetTitle($OptionsGui, "", $Msg[6])
					GUICtrlSetData($Group, $Msg[7])
					GUICtrlSetData($ImageLabel, $Msg[8])
					GUICtrlSetData($TempFileLabel, $Msg[9])
					GUICtrlSetData($DelTmpFileCB, $Msg[11])
					GUICtrlSetData($HotKeyLabel, $Msg[10])
					GUICtrlSetData($OK, $Msg[12])
					GUICtrlSetData($Cancel, $Msg[13])
				Case $OK
					GUISetState(@SW_HIDE, $OptionsGui)
					TraySetState(1)
					UnSetHotKeys()
					
					$UsedLang = "Lng_" & GUICtrlRead($LangCombo)
					$ImageEditor = GUICtrlRead($ImageEditorCombo)
					If Not StringInStr($ImageEditorList, $ImageEditor) Then _GUICtrlComboAddString($ImageEditorCombo, $ImageEditor)
					$ImageEditorList = _GUICtrlComboGetList($ImageEditorCombo)
					If StringRight($ImageEditorList, 2) = "|0" Then $ImageEditorList = StringTrimRight($ImageEditorList, 2)
					$TempBmpFile = _Iif(GUICtrlRead($TempBmpFileInput)="", $TempBmpFile, GUICtrlRead($TempBmpFileInput))
					
					$HotKey = GUICtrlRead($HotKeyCombo)
					$HotKeySet = SetHotkey($HotKey)
					HotKeySet($HotKeySet, "PrintScreen")
					
					$DeleteTmpFile = GUICtrlRead($DelTmpFileCB)
					If $DeleteTmpFile = 4 Then $DeleteTmpFile = 0
					
					IniWrite($Config, "Prefs", "Image Editor", $ImageEditor)
					IniWrite($Config, "Prefs", "Image Editor List", $ImageEditorList)
					IniWrite($Config, "Prefs", "Temp File", $TempBmpFile)
					IniWrite($Config, "Prefs", "HotKey", $HotKey)
					IniWrite($Config, "Prefs", "Delete Temp File", $DeleteTmpFile)
					IniWrite($Config, "Prefs", "Language", $UsedLang)
					
					$Msg = Translate($Config)
					
					TraySetToolTip(StringReplace($Msg[18], "%S", _Iif($IsOn=1, $Msg[3], $Msg[4])))
					TrayItemSetText($Options, $Msg[2])
					TrayItemSetText($TurnOn, $Msg[3])
					TrayItemSetText($TurnOff, $Msg[4])
					TrayItemSetText($Exit, $Msg[5])
					
					GUIDelete($OptionsGui)
					ExitLoop
				Case $Cancel, -3
					$UsedLang = $OldUsedLang
					$Msg = Translate($Config)
					GUIDelete($OptionsGui)
					ExitLoop
			EndSwitch
		WEnd
		TraySetState(1)
		$OptionsGui = ""
	EndIf
WEnd

Func Options()
	TraySetState(2)
	$OptionsGui = GUICreate($Msg[6], 400, 260, -1, -1, -1, $WS_EX_TOOLWINDOW+$WS_EX_APPWINDOW)
	
	$OldUsedLang = $UsedLang
	
	$Group = GUICtrlCreateGroup($Msg[7], 5, 30, 390, 185)
	$ImageLabel = GUICtrlCreateLabel($Msg[8], 10, 50, 130)
	$ImageEditorCombo = GUICtrlCreateCombo("", 135, 47, 245)
	GUICtrlSetData($ImageEditorCombo, $ImageEditorList, $ImageEditor)
	
	$TempFileLabel = GUICtrlCreateLabel($Msg[9], 10, 90, 110)
	$TempBmpFileInput = GUICtrlCreateInput($TempBmpFile, 120, 87, 260)
	
	$DelTmpFileCB = GUICtrlCreateCheckbox($Msg[11], 10, 120, 380)
	If $DeleteTmpFile = 1 Then GUICtrlSetState($DelTmpFileCB, 1)
	
	$HotKeyLabel = GUICtrlCreateLabel($Msg[10], 10, 160, 250)
	
	$HotKeyCombo = GUICtrlCreateCombo("", 270, 157, 110, 20, $CBS_DROPDOWNLIST)
	GUICtrlSetData($HotKeyCombo, "Print Screen|CTRL SHIFT P|CTRL SHIFT 0", $HotKey)
	
	GUICtrlCreateLabel("Language:", 10, 190)
	$LangCombo = GUICtrlCreateCombo("", 70, 187, 70, -1, $CBS_DROPDOWNLIST)
	$LangsList = _GetLangsList($Config)
	If $LangsList = -1 Then $LangsList = "English"
	GUICtrlSetData($LangCombo, $LangsList, StringReplace($UsedLang, "Lng_", ""))
	
	$OK = GUICtrlCreateButton($Msg[12], 250, 225, 60, 20)
	$Cancel = GUICtrlCreateButton($Msg[13], 330, 225, 60, 20)
	
	GUISetState()
EndFunc

Func Translate($LangFile)
	Local $MsgsCount = 20
	Local $Msg[$MsgsCount+1]
	$Msg[1] = "There was unknown error accourd, pleas try later..."
	$Msg[2] = "Options"
	$Msg[3] = "ON"
	$Msg[4] = "OFF"
	$Msg[5] = "Exit"
	$Msg[6] = "Print Screen Checker - Options"
	$Msg[7] = "General Prefs"
	$Msg[8] = "Images Editor:"
	$Msg[9] = "Temp File Path:"
	$Msg[10] = "Hot Key to capture image:"
	$Msg[11] = "Delete Temp File after capture image"
	$Msg[12] = "OK"
	$Msg[13] = "Cancel"
	$Msg[14] = "Generating image"
	$Msg[15] = "Collecting Data..."
	$Msg[16] = "Progress... "
	$Msg[17] = "Error"
	$Msg[18] = "Monitoring for 'Print Screen' is " & _Iif($IsOn=1, $Msg[3], $Msg[4])
	$Msg[19] = "The program is started"
	$Msg[20] = "*Click on this icon with right mouse button to show menu \n " & _
		"*Click with left mouse button to switch on/off the monitoring of 'Print Screen'"
	
	For $i = 1 To $MsgsCount
		$CurrentTrns = StringReplace(IniRead($LangFile, $UsedLang, "00" & $i, $Msg[$i]), "\n", @CRLF)
		If $CurrentTrns <> "" Then $Msg[$i] = $CurrentTrns
	Next
	Return $Msg
EndFunc

Func SwitchOnOff()
	If $IsOn = 1 Then
		HotKeySet($HotKeySet)
		TrayItemSetState($TurnOn, 4)
		TrayItemSetState($TurnOff, 1)
		TraySetIcon($IconFile, $OffIconID)
		$IsOn = 0
	ElseIf $IsOn = 0 Then
		HotKeySet($HotKeySet, "PrintScreen")
		TrayItemSetState($TurnOn, 1)
		TrayItemSetState($TurnOff, 4)
		TraySetIcon($IconFile, $OnIconID)
		$IsOn = 1
	EndIf
	$Msg = Translate($Config)
	TraySetToolTip(StringReplace($Msg[18], "%S", _Iif($IsOn=1, $Msg[3], $Msg[4])))
EndFunc

Func UnSetHotKeys()
	HotKeySet("{PrintScreen}")
	HotKeySet("^+p")
	HotKeySet("^+0")
EndFunc

Func SetHotkey($HotKey)
	Local $HotKeySet = "Print Screen"
	Switch $HotKey
		Case "Print Screen"
			$HotKeySet = "{PrintScreen}"
		Case "CTRL SHIFT P"
			$HotKeySet = "^+p"
		Case "CTRL SHIFT 0"
			$HotKeySet = "^+0"
	EndSwitch
	Return $HotKeySet
EndFunc

Func _GetLangsList($LangFile)
	Local $LangsSections = IniReadSectionNames($LangFile)
	If @error Then Return -1
	Local $LangsRetList = "", $LngIsExists = 0
	For $i = 1 To $LangsSections[0]
		If StringLeft($LangsSections[$i], 4) = "Lng_" Then
			$LangsRetList &= StringTrimLeft($LangsSections[$i], 4) & "|"
			$LngIsExists = 1
		EndIf
	Next
	If $LngIsExists = 0 Then Return -1
	Return $LangsRetList
EndFunc

Func PrintScreen()
	If $HotKeySet <> "{PrintScreen}" Then
		Send("{PrintScreen}")
		Sleep(500)
	EndIf
	UnSetHotKeys()
	Send($HotKeySet)
	HotKeySet($HotKeySet, "PrintScreen")
	ProgressOn($Msg[14], $Msg[15], $Msg[16] & " 0%")
	$Ret = ContentHandler($TempBmpFile)
	Sleep(300)
	ProgressOff()
	If Not $Ret Or Not FileExists($TempBmpFile) Then _
		Return MsgBox(262144+48, $Msg[17], $Msg[1])
	Local $EditorPid = ShellExecute($ImageEditor, '"' & $TempBmpFile & '"', "", "open", @SW_MAXIMIZE)
	
	ProcessWait($EditorPid, 3)
	If $DeleteTmpFile = 1 Then FileDelete($TempBmpFile)
EndFunc

Func ContentHandler($FileToSave)
	Local $buffer
	Local $clipbmp = GetClipBoard($buffer)
	If $clipbmp Then CreateDib($clipbmp, $FileToSave, $Msg[16])
	DeleteObject($clipbmp)
	Return $clipbmp
EndFunc

Func Quit()
	IniWrite($Config, "Prefs", "On/Off", $IsOn)
	Exit
EndFunc
